diff -bwcr wais-8-b5/ir/irbuild.c w8b5bio/ir/irbuild.c
*** wais-8-b5/ir/irbuild.c	Sun May 10 16:48:16 1992
--- w8b5bio/ir/irbuild.c	Sun Nov  8 18:59:38 1992
***************
*** 344,597 ****
  	panic("Expected a file type");
        if(0 == strcmp("groliers", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = groliers_separator_function;
! 	header_function = groliers_header_function;
! 	finish_header_function = groliers_finish_header_function;
        }
  #ifdef NeXT
        else if(0 == strcmp("objc", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = wobjc_separator_function;
! 	header_function = wobjc_header_function;
! 	finish_header_function = wobjc_finish_header_function;
        }
  #endif /* def NeXT */
        else if(0 == strcmp("mail", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = mail_separator_function;
! 	header_function = mail_header_function;
! 	date_function = mail_date_function;
! 	finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("mail_or_rmail", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = mail_or_rmail_separator;
! 	header_function = mail_header_function;
! 	date_function = mail_date_function;
! 	finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("mail_digest", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = mail_digest_separator_function;
!  	header_function = mail_header_function;
!  	date_function = mail_date_function;
!  	finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("mh_bboard", next_argument)){
   	typename = next_argument;
!  	type = "TEXT";
!  	separator_function = mh_bboard_separator_function;
! 	header_function = mail_header_function;
! 	date_function = mail_date_function;
! 	finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("rmail", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = rmail_separator_function;
! 	header_function = mail_header_function;
! 	date_function = mail_date_function;
! 	finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("netnews", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = NULL;
! 	header_function = mail_header_function;
! 	date_function = mail_date_function;
! 	finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("rn", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = rn_separator_function;
! 	header_function = mail_header_function;
! 	date_function = mail_date_function;
! 	finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("emacsinfo", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = emacs_info_separator_function;
! 	header_function = emacs_info_header_function;
! 	finish_header_function = emacs_info_finish_header_function;
        }
        else if(0 == strcmp("catalog", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = catalog_separator_function;
! 	header_function = catalog_header_function;
! 	finish_header_function = catalog_finish_header_function;
        }
        else if(0 == strcmp("bio", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = bio_separator_function;
! 	header_function = bio_header_function;
! 	finish_header_function = bio_finish_header_function;
        }
        else if(0 == strcmp("cmapp", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";	
! 	separator_function = cmapp_separator_function;
! 	header_function = cmapp_header_function;
! 	finish_header_function = cmapp_finish_header_function;
        }
        else if(0 == strcmp("ftp", next_argument)){
! 	type = "TEXT-FTP";
  	typename = next_argument;
! 	separator_function = first_line_separator_function;
! 	header_function = first_line_header_function;
! 	finish_header_function = first_line_finish_header_function;
        }
        else if(0 == strcmp("jargon", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = jargon_separator_function;
! 	header_function = jargon_header_function;
! 	finish_header_function = jargon_finish_header_function;
        }
        else if(0 == strcmp("server", next_argument)){
  	typename = next_argument;
! 	type = "WSRC";
! 	finish_header_function = filename_finish_header_function;
        }
        else if(0 == strcmp("text", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
  	check_for_text_file = true;
        }
        else if(0 == strcmp("filename", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	finish_header_function = filename_finish_header_function;
        }
        else if(0 == strcmp("irg", next_argument)){
  	typename = next_argument;
! 	type = "TEXT";
! 	separator_function = irg_separator_function;
! 	header_function = irg_header_function;
! 	finish_header_function = irg_finish_header_function;
        }
        /* dash-separated items , Intro to Algorithms buglist, etc */
        else if(0 == strcmp("dash", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = dash_separator_function;
! 	header_function = dash_header_function;
! 	finish_header_function = dash_finish_header_function;
        }
        /* one_line-separated items */
        else if(0 == strcmp("one_line", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = one_line_separator_function;
! 	header_function = one_line_header_function;
! 	finish_header_function = one_line_finish_header_function;
        }
        /* blank line-separated items (paragraphs) */
        else if(0 == strcmp("para", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = para_separator_function;
! 	header_function = para_header_function;
! 	finish_header_function = para_finish_header_function;
        }
        /* seeker items */
        else if(0 == strcmp("seeker", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = seeker_separator_function;
! 	header_function = seeker_header_function;
! 	finish_header_function = seeker_finish_header_function;
        }
        /* medline format */
        else if(0 == strcmp("medline", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = medline_separator_function;
! 	header_function = medline_header_function;
! 	finish_header_function = medline_finish_header_function;
        }
        /* refer format */
        else if(0 == strcmp("refer", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = refer_separator_function;
! 	header_function = refer_header_function;
! 	finish_header_function = refer_finish_header_function;
        }
        /* first_line format */
        else if(0 == strcmp("first_line", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = first_line_separator_function;
! 	header_function = first_line_header_function;
! 	finish_header_function = first_line_finish_header_function;
        }
        /* rlin items */
        else if(0 == strcmp("rlin", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = rlin_separator_function;
! 	header_function = rlin_header_function;
! 	finish_header_function = rlin_finish_header_function;
        }
        else if(0 == strcmp("dvi", next_argument)){
  	typename = next_argument;
! 	type = "DVI";
! 	finish_header_function = filename_finish_header_function;
        }
        else if(0 == strcmp("ps", next_argument)){
  	typename = next_argument;
! 	type = "PS";
! 	finish_header_function = filename_finish_header_function;
        }
        else if(0 == strcmp("pict", next_argument)){
  	typename = next_argument;
! 	type = "PICT";	
! 	finish_header_function = filename_finish_header_function;
  	index_contents = false;
        }
        else if(0 == strcmp("gif", next_argument)){
  	typename = next_argument;
! 	type = "GIF";	
! 	finish_header_function = filename_finish_header_function;
  	index_contents = false;
        }
        else if(0 == strcmp("tiff", next_argument)){
  	typename = next_argument;
! 	type = "TIFF";	
! 	finish_header_function = filename_finish_header_function;
  	index_contents = false;
        }
        /* BibTeX items */
        else if(0 == strcmp("bibtex", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = bibtex_separator_function;
! 	header_function = bibtex_header_function;
! 	finish_header_function = bibtex_finish_header_function;
        }
        /* ?:? seperated hypertext items */
        else if(0 == strcmp("nhyp", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = nhyp_separator_function;
! 	header_function = nhyp_header_function;
! 	finish_header_function = nhyp_finish_header_function;
        }
        else if(0 == strcmp("ziff", next_argument)){
! 	type = "TEXT";
  	typename = next_argument;
! 	separator_function = ziff_separator_function;
! 	header_function = ziff_header_function;
! 	finish_header_function = ziff_finish_header_function;
        }
        else{
  	panic("Don't recognize the '%s' type", next_argument);
--- 407,803 ----
  	panic("Expected a file type");
        if(0 == strcmp("groliers", next_argument)){
  	typename = next_argument;
! 	dataops.type ="TEXT";
! 	dataops.separator_function = groliers_separator_function;
! 	dataops.header_function = groliers_header_function;
! 	dataops.finish_header_function = groliers_finish_header_function;
        }
+ 
+ #ifdef BIO 
+        else if(0 == strcmp("genbank", next_argument)){/* dgg */
+  	typename = next_argument;
+  	dataops.type ="TEXT";
+  	dataops.separator_function = genbank_separator_function;
+  	dataops.header_function = genbank_header_function;
+  	dataops.finish_header_function = genbank_finish_header_function;
+  	dataops.date_function = genbank_date_function;
+ 	dataops.repeat_weight= 0;
+ 	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+ 	dataops.minwordlen= 2;
+        }
+        else if(0 == strcmp("embl", next_argument)){/* dgg */
+  	typename = next_argument;
+  	dataops.type ="TEXT";
+  	dataops.separator_function = embl_separator_function;
+  	dataops.header_function = embl_header_function;
+  	dataops.finish_header_function = embl_finish_header_function;
+  	dataops.date_function = embl_date_function;
+  	dataops.repeat_weight= 0;
+ 	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+       }
+        else if(0 == strcmp("pir", next_argument)){/* dgg */
+  	typename = next_argument;
+  	dataops.type = "TEXT";
+  	dataops.separator_function = pir_separator_function;
+  	dataops.header_function = pir_header_function;
+  	dataops.finish_header_function = pir_finish_header_function;
+  	dataops.date_function = pir_date_function;
+ 	dataops.repeat_weight= 0;
+  	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+       }
+         else if(0 == strcmp("prositedoc", next_argument)){ /* dgg */
+          typename = next_argument;
+          dataops.type = "TEXT";
+          dataops.separator_function = prositedoc_separator_function;
+          dataops.header_function = prositedoc_header_function;
+          dataops.finish_header_function = prositedoc_finish_header_function;
+   	 dataops.repeat_weight= 0;
+ 	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+        }
+        else if(0 == strcmp("prositedat", next_argument)){ /* dgg */
+          typename = next_argument;
+          dataops.type = "TEXT";
+          dataops.separator_function = prositedat_separator_function;
+          dataops.header_function = prositedat_header_function;
+          dataops.finish_header_function = prositedat_finish_header_function;
+   	 dataops.repeat_weight= 0;
+ 	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+        }
+        else if(0 == strcmp("biojournal", next_argument)){ /* dgg */
+          typename = next_argument;
+          dataops.type = "TEXT";
+          dataops.separator_function = biojournal_separator_function;
+          dataops.header_function = biojournal_header_function;
+          dataops.finish_header_function = biojournal_finish_header_function;
+   	 dataops.repeat_weight= 0;
+ 	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+        }
+  
+        else if(0 == strcmp("redbook", next_argument)){ /* dgg */
+  	typename = next_argument;
+  	dataops.type = "TEXT";
+  	dataops.separator_function = redbook_separator_function;
+  	dataops.header_function = redbook_header_function;
+  	dataops.finish_header_function = redbook_finish_header_function;
+   	dataops.repeat_weight= 0;
+ 	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+         dataops.wordDelimiter= wordbreak_user; /* redbook_delimiter;  */
+         wordDelimiter= wordbreak_user; /* wordbreak_notgraph; */
+ 	dataops.minwordlen= 1;
+ 	if (gDelimiters[0] == '\0') strcpy( gDelimiters, "/{}()[]%-:#.~*\";,|");
+        }
+        else if(0 == strcmp("flybase", next_argument)){ /* dgg */
+  	typename = next_argument;
+  	dataops.type = "TEXT";
+  	dataops.separator_function = flybase_separator_function;
+  	dataops.header_function = flybase_header_function;
+  	dataops.finish_header_function = flybase_finish_header_function;
+   	 dataops.repeat_weight= 0;
+ 	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+         dataops.wordDelimiter= wordbreak_user; /* flybase_delimiter;  */
+         wordDelimiter= wordbreak_user; /* wordbreak_notgraph; */
+ 	dataops.minwordlen= 1;
+ 	if (gDelimiters[0] == '\0') strcpy( gDelimiters, "-/{}:.~*\";,|");
+ 	
+ 	/* flybase symbols
+ 	  valid data ()$+-?;.\'
+ 	  possible data and delimiter |;[]-?.~
+ 	  delimiters 
+ 	  solution to confusion: set possible delimiters as delimiters, and
+ 	     permit literal searches with "..." or '...' enclosed strings.
+ 	*/
+ 	
+        }
+       else if(0 == strcmp("flystock", next_argument)){	/* dgg */
+ 	typename = next_argument;
+ 	dataops.type = "TEXT";
+ 	dataops.separator_function = bio_separator_function;
+ 	dataops.header_function = bio_header_function;
+ 	dataops.finish_header_function = bio_finish_header_function;
+   	 dataops.repeat_weight= 0;
+ 	dataops.addseparatorwords= true;
+ 	dataops.extraheaderweight= false;
+         dataops.wordDelimiter= wordbreak_user; /* flybase_delimiter;  */
+         wordDelimiter= wordbreak_user; /* wordbreak_notgraph; */
+ 	dataops.minwordlen= 1;
+ 	if (gDelimiters[0] == '\0') strcpy( gDelimiters, "-/{}:.~*\";,|");
+ 
+ 	/* flystock symbols
+ 	  valid data []()/-;?+.{}
+ 	  possible data and delimiter  =;.
+ 	    ;. in text field is del, in data field is data
+ 	  delimiters *";,
+ 	  more delimiters (from matthewk)  - / {} :
+ 	  
+ 	  solution to confusion: set possible delimiters as delimiters, and
+ 	     permit literal searches with "..." or '...' enclosed strings.
+ 	  ! want some way to provide field names (report "stylesheet") with
+ 	    searched/fetched records for flybase, flystock, other data files
+ 	  ! want "keyword [field]" limited searches for some of this to make sense !
+ 	*/
+       }
+ 
+       else if(0 == strcmp("din", next_argument)){
+ 	typename = next_argument;
+ 	dataops.type = "TEXT";
+ 	dataops.separator_function = din_separator_function;
+ 	dataops.header_function = din_header_function;
+ 	dataops.finish_header_function = din_finish_header_function;
+       }
+ 
+ #endif 
+ 
  #ifdef NeXT
        else if(0 == strcmp("objc", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = wobjc_separator_function;
! 	dataops.header_function = wobjc_header_function;
! 	dataops.finish_header_function = wobjc_finish_header_function;
        }
  #endif /* def NeXT */
        else if(0 == strcmp("mail", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = mail_separator_function;
! 	dataops.header_function = mail_header_function;
! 	dataops.date_function = mail_date_function;
! 	dataops.finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("mail_or_rmail", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = mail_or_rmail_separator;
! 	dataops.header_function = mail_header_function;
! 	dataops.date_function = mail_date_function;
! 	dataops.finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("mail_digest", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = mail_digest_separator_function;
!  	dataops.header_function = mail_header_function;
!  	dataops.date_function = mail_date_function;
!  	dataops.finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("mh_bboard", next_argument)){
   	typename = next_argument;
!  	dataops.type = "TEXT";
!  	dataops.separator_function = mh_bboard_separator_function;
! 	dataops.header_function = mail_header_function;
! 	dataops.date_function = mail_date_function;
! 	dataops.finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("rmail", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = rmail_separator_function;
! 	dataops.header_function = mail_header_function;
! 	dataops.date_function = mail_date_function;
! 	dataops.finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("netnews", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = NULL;
! 	dataops.header_function = mail_header_function;
! 	dataops.date_function = mail_date_function;
! 	dataops.finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("rn", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = rn_separator_function;
! 	dataops.header_function = mail_header_function;
! 	dataops.date_function = mail_date_function;
! 	dataops.finish_header_function = mail_finish_header_function;
        }
        else if(0 == strcmp("emacsinfo", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = emacs_info_separator_function;
! 	dataops.header_function = emacs_info_header_function;
! 	dataops.finish_header_function = emacs_info_finish_header_function;
        }
        else if(0 == strcmp("catalog", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = catalog_separator_function;
! 	dataops.header_function = catalog_header_function;
! 	dataops.finish_header_function = catalog_finish_header_function;
        }
        else if(0 == strcmp("bio", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = bio_separator_function;
! 	dataops.header_function = bio_header_function;
! 	dataops.finish_header_function = bio_finish_header_function;
        }
        else if(0 == strcmp("cmapp", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";	
! 	dataops.separator_function = cmapp_separator_function;
! 	dataops.header_function = cmapp_header_function;
! 	dataops.finish_header_function = cmapp_finish_header_function;
        }
        else if(0 == strcmp("ftp", next_argument)){
! 	dataops.type = "TEXT-FTP";
  	typename = next_argument;
! 	dataops.separator_function = first_line_separator_function;
! 	dataops.header_function = first_line_header_function;
! 	dataops.finish_header_function = first_line_finish_header_function;
        }
        else if(0 == strcmp("jargon", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = jargon_separator_function;
! 	dataops.header_function = jargon_header_function;
! 	dataops.finish_header_function = jargon_finish_header_function;
        }
        else if(0 == strcmp("server", next_argument)){
  	typename = next_argument;
! 	dataops.type = "WSRC";
! 	dataops.finish_header_function = filename_finish_header_function;
        }
        else if(0 == strcmp("text", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
  	check_for_text_file = true;
        }
        else if(0 == strcmp("filename", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.finish_header_function = filename_finish_header_function;
        }
        else if(0 == strcmp("irg", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TEXT";
! 	dataops.separator_function = irg_separator_function;
! 	dataops.header_function = irg_header_function;
! 	dataops.finish_header_function = irg_finish_header_function;
        }
        /* dash-separated items , Intro to Algorithms buglist, etc */
        else if(0 == strcmp("dash", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = dash_separator_function;
! 	dataops.header_function = dash_header_function;
! 	dataops.finish_header_function = dash_finish_header_function;
        }
        /* one_line-separated items */
        else if(0 == strcmp("one_line", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = one_line_separator_function;
! 	dataops.header_function = one_line_header_function;
! 	dataops.finish_header_function = one_line_finish_header_function;
        }
        /* blank line-separated items (paragraphs) */
        else if(0 == strcmp("para", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = para_separator_function;
! 	dataops.header_function = para_header_function;
! 	dataops.finish_header_function = para_finish_header_function;
        }
        /* seeker items */
        else if(0 == strcmp("seeker", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = seeker_separator_function;
! 	dataops.header_function = seeker_header_function;
! 	dataops.finish_header_function = seeker_finish_header_function;
        }
        /* medline format */
        else if(0 == strcmp("medline", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = medline_separator_function;
! 	dataops.header_function = medline_header_function;
! 	dataops.finish_header_function = medline_finish_header_function;
        }
        /* refer format */
        else if(0 == strcmp("refer", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = refer_separator_function;
! 	dataops.header_function = refer_header_function;
! 	dataops.finish_header_function = refer_finish_header_function;
        }
        /* first_line format */
        else if(0 == strcmp("first_line", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = first_line_separator_function;
! 	dataops.header_function = first_line_header_function;
! 	dataops.finish_header_function = first_line_finish_header_function;
        }
        /* rlin items */
        else if(0 == strcmp("rlin", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = rlin_separator_function;
! 	dataops.header_function = rlin_header_function;
! 	dataops.finish_header_function = rlin_finish_header_function;
        }
        else if(0 == strcmp("dvi", next_argument)){
  	typename = next_argument;
! 	dataops.type = "DVI";
! 	dataops.finish_header_function = filename_finish_header_function;
        }
        else if(0 == strcmp("ps", next_argument)){
  	typename = next_argument;
! 	dataops.type = "PS";
! 	dataops.finish_header_function = filename_finish_header_function;
        }
        else if(0 == strcmp("pict", next_argument)){
  	typename = next_argument;
! 	dataops.type = "PICT";	
! 	dataops.finish_header_function = filename_finish_header_function;
  	index_contents = false;
        }
        else if(0 == strcmp("gif", next_argument)){
  	typename = next_argument;
! 	dataops.type = "GIF";	
! 	dataops.finish_header_function = filename_finish_header_function;
  	index_contents = false;
        }
        else if(0 == strcmp("tiff", next_argument)){
  	typename = next_argument;
! 	dataops.type = "TIFF";	
! 	dataops.finish_header_function = filename_finish_header_function;
  	index_contents = false;
        }
        /* BibTeX items */
        else if(0 == strcmp("bibtex", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = bibtex_separator_function;
! 	dataops.header_function = bibtex_header_function;
! 	dataops.finish_header_function = bibtex_finish_header_function;
        }
        /* ?:? seperated hypertext items */
        else if(0 == strcmp("nhyp", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = nhyp_separator_function;
! 	dataops.header_function = nhyp_header_function;
! 	dataops.finish_header_function = nhyp_finish_header_function;
        }
        else if(0 == strcmp("ziff", next_argument)){
! 	dataops.type = "TEXT";
  	typename = next_argument;
! 	dataops.separator_function = ziff_separator_function;
! 	dataops.header_function = ziff_header_function;
! 	dataops.finish_header_function = ziff_finish_header_function;
        }
        else{
  	panic("Don't recognize the '%s' type", next_argument);
***************
*** 636,641 ****
--- 842,852 ----
      if (db == NULL)
        panic("unable to open the database");
    }
+   
+ #ifdef BIO
+     write_delimiters(gDelimiters, db);
+ #endif
+ 
    { /* set up the memory hashtable */
  
      if(memory_to_use < 0){ /* default */
***************
*** 677,683 ****
    while(NULL != next_argument){ /* the first filename is in next_argument already */
      if(directoryp(next_argument)){
         if(traverse_directory){
! 	 index_directory(next_argument,
  			 separator_function,
  			 header_function,
  			 date_function,
--- 888,898 ----
    while(NULL != next_argument){ /* the first filename is in next_argument already */
      if(directoryp(next_argument)){
         if(traverse_directory){
! 	 index_directory(next_argument, &dataops, db,
! 			 check_for_text_file,
! 			 adding_to_existing_index, 
! 			 word_positions, word_pairs);
! /*	 index_directory(next_argument,
  			 separator_function,
  			 header_function,
  			 date_function,
***************
*** 685,697 ****
  			 type, db,
  			 check_for_text_file,
  			 adding_to_existing_index, 
! 			 word_positions, word_pairs);
         }
       }
      else{			/* not a directory */
        waislog(WLOG_MEDIUM, WLOG_INDEX, 
  	      "Indexing file: %s", next_argument);
!       index_text_file(next_argument,
  		      separator_function,
  		      header_function,
  		      date_function,
--- 900,915 ----
  			 type, db,
  			 check_for_text_file,
  			 adding_to_existing_index, 
! 			 word_positions, word_pairs, minwordlen); */
         }
       }
      else{			/* not a directory */
        waislog(WLOG_MEDIUM, WLOG_INDEX, 
  	      "Indexing file: %s", next_argument);
!       index_text_file(next_argument, &dataops, db, 
! 		      check_for_text_file, adding_to_existing_index,
! 		      word_positions, word_pairs);
! /*      index_text_file(next_argument,
  		      separator_function,
  		      header_function,
  		      date_function,
***************
*** 698,704 ****
  		      finish_header_function,
  		      type, db, 
  		      check_for_text_file, adding_to_existing_index,
! 		      word_positions, word_pairs);
      }
      if (read_files_from_stdin) {
        if (0 != (next_argument = fgets(data_filename, MAXPATHLEN, stdin))) {
--- 916,922 ----
  		      finish_header_function,
  		      type, db, 
  		      check_for_text_file, adding_to_existing_index,
! 		      word_positions, word_pairs, minwordlen); */
      }
      if (read_files_from_stdin) {
        if (0 != (next_argument = fgets(data_filename, MAXPATHLEN, stdin))) {
diff -bwcr wais-8-b5/ir/ircfiles.c w8b5bio/ir/ircfiles.c
*** wais-8-b5/ir/ircfiles.c	Wed May  6 19:27:43 1992
--- w8b5bio/ir/ircfiles.c	Sun Nov  8 19:09:51 1992
***************
*** 104,109 ****
--- 104,113 ----
  #define MAX_AUTHOR_LEN 25
  #define MAX_DATE_LEN 4
  
+ static char *months[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
+ 			"Jul", "Aug", "Sep", "Oct", "Nov", "Dec", NULL};
+ 
+ 
  static char* trim_trailing_newline _AP((char* string));
  
  static char*
